#
#ident  "@(#)isdntool_base.tcl	1.19 96/03/07 SMI"
#
# Copyright (c) 1993 by Sun Microsystems, Inc.
#
# ISDN configuration tool
#
# isdntool main window
#
proc help_trace { w } {
	if {[winfo exists $w] == 1} {
		wm deiconify $w
		return 
	}
	toplevel $w
	wm title $w "Help on Trace Window"
	wm iconname $w "help_trace"
	wm iconbitmap $w @ppm/logo.bmp
        button $w.ok -text OK -command "destroy $w"
        text $w.t -relief sunken -bd 2 -yscrollcommand "$w.s set" -setgrid true \
         	-bg lightgrey  -height 8
        scrollbar $w.s -command "$w.t yview"
        pack $w.ok -side bottom -fill x
        pack $w.s -side right -fill y 
        pack $w.t -expand yes -fill both -expand true 
        $w.t insert 0.0 \
{Trace button will initiate isdn D-Channel signalling trace, and display the 
trace output on the subsequent pop up window.

The isdntrace will be stopped after being "Dismissed" . All the current
output will be lost.
 }
}
proc help_stop { w } {
	if {[winfo exists $w] == 1} {
		wm deiconify $w
		return 
	}
	toplevel $w
	wm title $w "Help on Stop Window"
	wm iconname $w "help_stop"
	wm iconbitmap $w @ppm/logo.bmp
        button $w.ok -text OK -command "destroy $w"
        text $w.t -relief sunken -bd 2 -yscrollcommand "$w.s set" -setgrid true \
         	-bg lightgrey  -height 8
        scrollbar $w.s -command "$w.t yview"
        pack $w.ok -side bottom -fill x
        pack $w.s -side right -fill y 
        pack $w.t -expand yes -fill both -expand true 
        $w.t insert 0.0 \
{Stop button will stop the isdn process execution. The result of the Stop
will be displayed in the subsequent pop up Stop window. 

This WILL NOT stop the isppp process. }

}
proc help_start { w } {
	if {[winfo exists $w] == 1} {
		wm deiconify $w
		return 
	}
	toplevel $w
	wm title $w "Help on Start Window"
	wm iconbitmap $w @ppm/logo.bmp
	wm iconname $w "help_start"
        button $w.ok -text OK -command "destroy $w"
        text $w.t -relief sunken -bd 2 -yscrollcommand "$w.s set" -setgrid true \
         	-bg lightgrey  -height 8
        scrollbar $w.s -command "$w.t yview"
        pack $w.ok -side bottom -fill x
        pack $w.s -side right -fill y 
        pack $w.t -expand yes -fill both -expand true 
        $w.t insert 0.0 \
{Start Button will invoke the isdn process. The result of the Start will be 
displayed in the subsequent pop up Start Window.

This WILL NOT start the isppp process, please use "isppp start" command. 
}
}

proc help_log { w } {
	if {[winfo exists $w] == 1} {
		wm deiconify $w
		return 
	}
	toplevel $w
	wm title $w "Help on Log Window"
	wm iconbitmap $w @ppm/logo.bmp
	wm iconname $w "help_log"
        button $w.ok -text OK -command "destroy $w"
        text $w.t -relief sunken -bd 2 -yscrollcommand "$w.s set" -setgrid true \
         	-bg lightgrey  -height 8
        scrollbar $w.s -command "$w.t yview"
        pack $w.ok -side bottom -fill x
        pack $w.s -side right -fill y 
        pack $w.t -expand yes -fill both -expand true 
        $w.t insert 0.0 \
{The Log Button / Log Window displays the operation log from SunISDN 1.0.2.

This same log can be obtained from /var/opt/SUNWisdn/te/log. This is a 
journal of the SunISDN operations.
}
}


proc help_option { w } {
	if {[winfo exists $w] == 1} {
		wm deiconify $w
		return 
	}
	toplevel $w
	wm title $w "Help on Options Window"
	wm iconbitmap $w @ppm/logo.bmp
	wm iconname $w "help_opt"
	button $w.ok -text OK -command "destroy $w" 
	text $w.t -relief sunken -bd 2 -yscrollcommand "$w.s set" -setgrid true\
		-bg lightgrey 
	scrollbar $w.s -command "$w.t yview"
    	pack $w.ok -side bottom -fill x
    	pack $w.s -side right -fill y 
    	pack $w.t -expand yes -fill both -expand true
	$w.t insert 0.0 \
{Option Button / Option Window allows you to configure isdn configuration files,
namely, /etc/opt/SUNWisdn/te/?. 

1. Physical Interfaces:
	
	The entries in this list indicates the number of ISDN hardware 
	devices avaliable to the system. Please select the device to 
	configure by clicking on the entry.

	When you highlight one of the entry value(s) it applies to 
	Network Type, Profile A and Profile B.

	The default value is isdn_0.

2. Network Type:
	
	This entry determines the switch type currently connected to the
	device. SunISDN 1.0.2 supports 9 switch types. Please click on
	the arrow box next to the display widget for supported switch
	types.

3. Profile A/B :

	This section of the window determines the profile for first/second
	calling number of your ISDN line(s). 

	calling number : your ISDN phone number.

	sub address : your ISDN subaddress.

	spid : your ISDN service profile ID.

	local : popup local address / local sub address screen. 

		SunISDN 1.0.2 supports up to 4 local addresses / local 
		subaddresses.

	cli : calling line indentifier.

	force56 : Force the ISDN line do 56Kb transfer rate, regardless of 
   		  the incoming call identifies itself. This is mainly used 
		  for incompatability problems between switches.

	Please get all the above configuration parameters from your ISDN 
	provider.

4. dismiss button :

	Close out the option window.

5. reset button :

	Reset the configuration parameter to the value when isdntool was 
	first invoked.

6. apply button :

	Apply the changes to /etc/opt/SUNWisdn/te directory.

	Note, isdntool will make a SINGLE BACKUP COPY ON EACH APPLY. If you
	make a mistake in applying the configuration, the old configuration 
	file can be retrieved from /etc/opt/SUNWisdn/te/#.bak file.
}

	

}

proc MkMainMenu {top} {

    set w [frame $top.f1 -bd 2 -relief raised]

    menubutton $w.file -menu $w.file.m -text File -underline 0
#    menubutton $w.props -menu $w.props.m -text Properties -underline 0
    menubutton $w.help -menu $w.help.m -text Help -underline 0

    menu $w.file.m
    $w.file.m add command -label "Exit" -command exit -underline 1
   
#    menu $w.props.m
#    $w.props.m add command -label "" -command ""  -underline 1

    menu $w.help.m
    $w.help.m add command -under 3  -label "On Options" \
        -command "help_option .help_option" 
    $w.help.m add command -under 3  -label "On Start" \
        -command "help_start .help_start"
    $w.help.m add command -under 6  -label "On Stop" \
        -command "help_stop .help_stop"
    $w.help.m add command -under 3  -label "On Log" \
        -command "help_log .help_log"
    $w.help.m add command -under 3  -label "On Trace" \
        -command "help_trace .help_trace"
#    $w.help.m add command 	    -label "" \
#        -command ""
 
    tixForm $w.file -left 0 
#    tixForm $w.props -left 40 
    tixForm $w.help -right -1
 
    return $w
}
 

# set window title  
set title "isdntool 1.0.2"

wm title . $title

# allow resizing
wm minsize . 400 140
wm geometry . 400x140
wm maxsize . 400 140
wm positionfrom . user
# iconify window upon start-up
wm iconbitmap . @ppm/logo.bmp

wm iconname . "isdntool" 

# enforce background color
. config -background lightgrey

# create image

image create photo img1 -format PPM -file ppm/config1.ppm
image create photo img2 -format PPM -file ppm/go.ppm
image create photo img3 -format PPM -file ppm/stop.ppm
image create photo img4 -format PPM -file ppm/log2.ppm
image create photo img5 -format PPM -file ppm/trace0.ppm

# TODO:  create img6 
#image create photo img6 -format PPM -file ppm/config1.ppm

# create menus

set frame1 [MkMainMenu     .]
pack $frame1 -side top    -fill x
 

#create left/right frames

frame .frame -borderwidth 10
frame .left  -borderwidth 10
frame .right -borderwidth 10

# create the various widgets


set stopped 1 
button .stop -image img3 -command {
			create_stop .isdn_stop "bogus"
}
button .start -image img2 -command { 
			create_start .isdn_start "bogus"
}
button .option -image img1 -command {  
			create_options  .isdn_options "bogus" 
} 
button .log -image img4 -command {
			create_log .isdn_log "bogus"	
}
button .trace -image img5 -command { 
		 	create_trace .isdn_trace "bogus"	
}
#button .utility  -image img1 -command { 
#}

# arrange the various widgets 

pack .left -side  top
pack .right -side top

pack .option -in .left -side left -fill both -expand yes
pack .start -in .left -side left -fill both -expand yes
pack .stop -in .left -side left -fill both -expand yes
pack .trace -in .left -side left -fill both -expand yes
pack .log -in .left -side left -fill both -expand yes
#pack .utility -in .left -side left -fill both -expand yes


# create balloon help label 
label .status 
pack .status -side bottom -fill y -padx 2 -pady 1

# create balloon's
tixBalloon .balloon -statusbar .status

.balloon bind .option -balloonmsg "Options" \
    -statusmsg "Press this button to configure isdn"
.balloon bind .start -balloonmsg "Start" \
    -statusmsg "Press this button to start isdn"
.balloon bind .stop -balloonmsg "Stop" \
    -statusmsg "Press this button to stop isdn"
.balloon bind .log -balloonmsg "Log" \
    -statusmsg "Press this button to invoke the log"
.balloon bind .trace -balloonmsg "Trace" \
    -statusmsg "Press this button to invoke the trace"
#.balloon bind .utility -balloonmsg "util" \
#    -statusmsg "Press this button to invoke the utility"


# refresh
update idletasks
