#
#ident  "@(#)isdntool_init.tcl	1.16 96/02/12 SMI"
#
# Copyright (c) 1993 by Sun Microsystems, Inc.
#
# ISDN configuration tool
#
#
# File: isdn_init.tcl #
#
#

#
# verify we're root user
#
set id [exec /usr/bin/id]
if { [ lindex $id 0 ] != "uid=0(root)" } {
    puts "must be root to invoke isdntool"
    exit 1
}

#
if { ![file exists /etc/opt/SUNWisdn/te] } {
                puts "isdn configuration directory does not exist!"
                puts "please check your isdn installation"
    		exit 1
}

#
# Insist on running with compatible versions of Tcl and Tk.
 
scan [info tclversion] "%d.%d" a b
if {$a != 7} {
    error "wrong version of Tcl loaded ([info tclversion]): need 7.x"
}
scan $tk_version "%d.%d" a b
if {($a != 4) || ($b < 0)} {
    error "wrong version of Tk loaded ($tk_version): need 4.0 or later"
}
unset a b

#
set isdntool_library 	"."
# Add isdntool's directory to the end of the auto-load search path:
lappend auto_path $isdntool_library 

# 
# Invoke isdn parser and source the configuration lists if success
# or pop-up an error window. 
#

set parsing_error 0
set parsing_error  [ isdn_parse ]

if { $parsing_error == 1 } {
	source "/tmp/.tcl_config_file"
} else {
	create_err .isdn_err "bogus" 
	source "/tmp/.tcl_config_file"
}

#
# SIMULATION CODE
#
set simulation	0

if { $simulation } {
set currlist {		cc_nai 0 \
		 	cc_calling_nb 11111 \
			cc_na_country usa \
			cc_na_operator ins64\
			cc_nai 1 \
		 	cc_calling_nb 22222 \
			cc_na_country usa \
			cc_na_operator ins64 \
			ns_nai	0\
			ns_na_country usa \
			ns_na_operator_type ins64\
			ns_spid 33333\
			ns_nai	1\
			ns_na_country usa \
			ns_na_operator_type ins64 \
			ns_spid 44444 \
}
set isdnlist0 {		cc_nai 0 \
		 	cc_calling_nb 11111 \
			cc_na_country usa \
			cc_na_operator ins64\
			cc_nai 1 \
			cc_force56 1 \
			cc_cli 1 \
		 	cc_calling_nb 22222 \
			cc_na_country usa \
			cc_na_operator ins64 \
			ns_nai	0\
			ns_na_country usa \
			ns_na_operator_type ins64\
			ns_spid 33333\
			ns_nai	1\
			ns_na_country usa \
			ns_na_operator_type ins64 \
			ns_spid 44444 \
}

set isdnlist1 {		cc_nai 0 \
		 	cc_calling_nb 99991 \
			cc_na_country usa \
			cc_na_operator ni2 \
			cc_nai 1 \
			cc_force56 0 \
			cc_cli 1 \
		 	cc_calling_nb 88888 \
			cc_na_country usa \
			cc_na_operator ni2 \
			ns_nai	0\
			ns_na_country usa \
			ns_na_operator_type ni2 \
			ns_spid 77777\
			ns_nai	1\
			ns_na_country usa \
			ns_na_operator_type ni2 \
			ns_spid 66666 \
}

} 
# END OF SIMULATION

foreach i {0 1 2 3 4 5 6 7 8 9 10 11} {
	set jk isdn$i
	set tmp tmp$i
	set ${jk}(cn1) ""
	set ${jk}(cn2) ""
	set ${jk}(sa1) ""
	set ${jk}(sa2) ""
	set ${jk}(la1) ""
	set ${jk}(la2) ""
	set ${jk}(la3) ""
	set ${jk}(la4) ""
	set ${jk}(lsa1) ""
	set ${jk}(lsa2) ""
	set ${jk}(lsa3) ""
	set ${jk}(lsa4) ""
	set ${jk}(la5) ""
	set ${jk}(la6) ""
	set ${jk}(la7) ""
	set ${jk}(la8) ""
	set ${jk}(lsa5) ""
	set ${jk}(lsa6) ""
	set ${jk}(lsa7) ""
	set ${jk}(lsa8) ""
	set ${jk}(spid1) ""
	set ${jk}(spid2) ""
	set ${jk}(cli1) ""
	set ${jk}(cli2) ""
	set ${jk}(cf561) ""
	set ${jk}(cf562) ""
	set ${jk}(switch_type) ""
	set ${jk}(country) ""

	set ${tmp}(cn1) ""
	set ${tmp}(cn2) ""
	set ${tmp}(sa1) ""
	set ${tmp}(sa2) ""
	set ${tmp}(la1) ""
	set ${tmp}(la2) ""
	set ${tmp}(la3) ""
	set ${tmp}(la4) ""
	set ${tmp}(lsa1) ""
	set ${tmp}(lsa2) ""
	set ${tmp}(lsa3) ""
	set ${tmp}(lsa4) ""
	set ${tmp}(la5) ""
	set ${tmp}(la6) ""
	set ${tmp}(la7) ""
	set ${tmp}(la8) ""
	set ${tmp}(lsa5) ""
	set ${tmp}(lsa6) ""
	set ${tmp}(lsa7) ""
	set ${tmp}(lsa8) ""
	set ${tmp}(spid1) ""
	set ${tmp}(spid2) ""
	set ${tmp}(cli1) ""
	set ${tmp}(cli2) ""
	set ${tmp}(cf561) ""
	set ${tmp}(cf562) ""
	set ${tmp}(switch_type) ""
	set ${tmp}(country) ""

}
# find configuration list numbers
set nb_card 0
set i 0
while {[info exists isdnlist$i] == 1} {
	incr i 1
	incr nb_card 1
}
# find value in keywords
for {set j 0 } {$j < $nb_card} {incr j 1} {

# isdn$j array is holding the current value 
# tmp$j array is holding the value originally from the parser for reset purpose
	set jk isdn$j
	set tmp tmp$j
	set x 0
	set cn1_flag 0
	set cn2_flag 0
	set sa1_flag 0
	set spid1_flag 0
	set force56_flag 0
	set cli_flag 0
	set la_flag 1
	set lsa_flag 1
	set listname isdnlist$j
	set lncmd "\lindex \$\{$listname\} \$x"
	
	foreach i [set isdnlist$j] {
		set x [expr $x + 1 ]
        	switch -exact $i {
                	cc_na_operator { 
				set ${jk}(switch_type) [eval $lncmd]
				set ${tmp}(switch_type) [eval $lncmd]
			}
	
                	cc_na_country { 
				set ${jk}(country) [eval $lncmd]
				set ${tmp}(country) [eval $lncmd]
			}

                	cc_calling_nb {
                        	if { $cn1_flag == 1 } {
                                	set ${jk}(cn2) [eval  $lncmd ]
                                	set ${tmp}(cn2) [eval  $lncmd ]
					set cn2_flag 1

                        	} else {
                                	set ${jk}(cn1) [eval  $lncmd ]
                                	set ${tmp}(cn1) [eval  $lncmd ]
                        	} 
                        	set cn1_flag 1
			}
                	cc_local_sub_add {
				if  {$cn2_flag == 1} { set lsa_flag 5}
				switch -exact $lsa_flag {
					1 { set ${jk}(lsa1) [eval $lncmd ]
					    set ${tmp}(lsa1) [eval $lncmd ]
					}
					2 { set ${jk}(lsa2) [eval $lncmd ]
					    set ${tmp}(lsa2) [eval $lncmd ]
					}
					3 { set ${jk}(lsa3) [eval $lncmd ]
					    set ${tmp}(lsa3) [eval $lncmd ]
					}
					4 { set ${jk}(lsa4) [eval $lncmd ]
					    set ${tmp}(lsa4) [eval $lncmd ]
					}
					5 { set ${jk}(lsa5) [eval $lncmd ]
					    set ${tmp}(lsa5) [eval $lncmd ]
					}
					6 { set ${jk}(lsa6) [eval $lncmd ]
					    set ${tmp}(lsa6) [eval $lncmd ]
					}
					7 { set ${jk}(lsa7) [eval $lncmd ]
					    set ${tmp}(lsa7) [eval $lncmd ]
					}
					8 { set ${jk}(lsa8) [eval $lncmd ]
					    set ${tmp}(lsa8) [eval $lncmd ]
					}
				}
				set lsa_flag [expr $lsa_flag + 1]
			}
                	cc_local_nb {
				if  {$cn2_flag == 1} { set la_flag 5}
				switch -exact $la_flag {
					1 { set ${jk}(la1) [eval $lncmd ]
					    set ${tmp}(la1) [eval $lncmd ]
					}
					2 { set ${jk}(la2) [eval $lncmd ]
					    set ${tmp}(la2) [eval $lncmd ]
					}
					3 { set ${jk}(la3) [eval $lncmd ]
					    set ${tmp}(la3) [eval $lncmd ]
					}
					4 { set ${jk}(la4) [eval $lncmd ]
					    set ${tmp}(la4) [eval $lncmd ]
					}
					5 { set ${jk}(la5) [eval $lncmd ]
					    set ${tmp}(la5) [eval $lncmd ]
					}
					6 { set ${jk}(la6) [eval $lncmd ]
					    set ${tmp}(la6) [eval $lncmd ]
					}
					7 { set ${jk}(la7) [eval $lncmd ]
					    set ${tmp}(la7) [eval $lncmd ]
					}
					8 { set ${jk}(la8) [eval $lncmd ]
					    set ${tmp}(la8) [eval $lncmd ]
					}
				}
				set la_flag [expr $la_flag + 1]
			}
                	cc_calling_sub_add {
                        	if { $sa1_flag == 1 } {
                                	set ${jk}(sa2) [eval $lncmd ]
                                	set ${tmp}(sa2) [eval $lncmd ]
                        	} else {
                                	set ${jk}(sa1) [eval $lncmd]
                                	set ${tmp}(sa1) [eval $lncmd]
                        	} 
                        	set sa1_flag 1
			}
                	ns_spid {
                        	if { $spid1_flag == 1 } {
                                	set ${jk}(spid2) [eval $lncmd]
                                	set ${tmp}(spid2) [eval $lncmd]
                        	} else {
                                	set ${jk}(spid1) [eval $lncmd]
                                	set ${tmp}(spid1) [eval $lncmd]
                        	}
                        	set spid1_flag 1
                	}
                	cc_force56 {
                        	if { $force56_flag == 1 } {
                                	set ${jk}(cf562) [eval $lncmd]
                                	set ${tmp}(cf562) [eval $lncmd]
                        	} else {
                                	set ${jk}(cf561) [eval $lncmd]
                                	set ${tmp}(cf561) [eval $lncmd]
                        	}
                        	set force56_flag 1
			}
                	cc_cli {
                        	if { $cli_flag == 1 } {
                                	set ${jk}(cli2) [eval $lncmd]
                                	set ${tmp}(cli2) [eval $lncmd]
                        	} else {
                                	set ${jk}(cli1) [eval $lncmd]
                                	set ${tmp}(cli1) [eval $lncmd]
                        	} 
                        	set cli_flag 1   
                	} 
        	}
	}
	if {[set ${jk}(country)] == "sweden"} {
		set ${jk}(switch_type) "swd-etsi"
		set ${tmp}(switch_type) "swd-etsi"
	}
	 
}

# end
