#
#ident  "@(#)isdntool_log.tcl	1.15 95/04/07 SMI"
#
# Copyright (c) 1993 by Sun Microsystems, Inc.
#
# ISDN configuration tool

#
#
# menu bar
#

proc MkLogMenu {top} {

    set w [frame $top.localf1 -bd 2 -relief raised]

    menubutton $w.file -menu $w.file.m -text File -underline 0
    menubutton $w.help -menu $w.help.m -text Help -underline 0

    menu $w.file.m
    $w.file.m add command -label "Dismiss" -command "destroy $top"  \
        -underline 0

    menu $w.help.m
    $w.help.m add command -under 0  -label "On Log" \
        -command "help_log .help_log"

    tixForm $w.file
    tixForm $w.help -right -1

    return $w
}


#
# Log callback.
#

proc LogInput  { }  {
        global textLogWin
        global logFileId
        if {[gets $logFileId line] < 0} {
		close $logFileId
		set line "\n...end of log...\n"
        }
  	if { [winfo exists  .isdn_log.textLog] == 1 } {
		$textLogWin insert end "$line\n"
		$textLogWin yview -pickplace end
	}
}

proc destroy_log {} {
        global logFileId
        set f [pid $logFileId]
        catch {destroy .isdn_log}
        catch [exec kill -9 $f]
        close $logFileId
}


proc create_log { w  args } {

  	if { [winfo exists  $w] == 1 } {
		wm deiconify $w
		return
  	}

	toplevel $w
	wm title $w {isdnlog}
	wm positionfrom $w ""
	wm sizefrom $w ""
	wm minsize $w 100 100
        wm iconname $w "log"
        wm iconbitmap $w @ppm/logo.bmp

	# create menu widgets(s)
 
	set frame1 [MkLogMenu       $w]
        pack $frame1 -side top    -fill x


	# create text widget

	text $w.textLog -relief raised -bd 2 -yscrollcommand "$w.scroll set" \
		-background lightgrey

	scrollbar $w.scroll -command "$w.textLog yview"
	pack $w.scroll -side right -fill y
	pack $w.textLog -side top -fill both -expand true

        frame $w.dismiss -bd 2  -relief raised
        pack $w.dismiss -side bottom -fill x -in $w
        button $w.dismiss.dismiss -text Dismiss -command { destroy_log } 
        pack $w.dismiss.dismiss -in $w.dismiss -side bottom -fill x

	update idletasks

	set logfile "/var/adm/SUNWisdn/log"
	# logfile should be passed as an argument

	global textLogWin
	set textLogWin $w.textLog
	global logFileId
	#set logFileId [ open {|tail -f /var/SUNWisdn/log} r ]
	set logFileId [ open {|tail -f /var/opt/SUNWisdn/log} ]
	fileevent $logFileId readable LogInput
	update idletasks

}

