#ident  "@(#)isdntool_options.tcl	1.20 96/02/12 SMI"
#
# Copyright (c) 1993 by Sun Microsystems, Inc.
#
# ISDN configuration tool
#
proc help_local { w } {
        if {[winfo exists $w] == 1} {
                wm deiconify $w
                return
        }
        toplevel $w
        wm title $w "Help on Local Window"
        wm iconname $w "help_local"
        button $w.ok -text OK -command "destroy $w"
        text $w.t -relief sunken -bd 2 -yscrollcommand "$w.s set" -setgrid true \
                -bg lightgrey  -height 8
        scrollbar $w.s -command "$w.t yview"
        pack $w.ok -side bottom -fill x
        pack $w.s -side right -fill y
        pack $w.t -expand yes -fill both -expand true
        $w.t insert 0.0 \
{Local Windows let you specifies the local calling addresses and locall calling
sub-addresses. These are option features and you might want to check with your
ISDN provider on the avalibility of these provisions. }

}

# create local1 menu bar
proc MkLocal1Menu {top} {

    set w [frame $top.localf1 -bd 2 -relief raised]
 
    menubutton $w.file -menu $w.file.m -text File -underline 0
    menubutton $w.help -menu $w.help.m -text Help -underline 0
 
    menu $w.file.m
    $w.file.m add command -label "Dismiss" -command "destroy $top"  \
	-underline 0 
 
    menu $w.help.m
    $w.help.m add command -under 0  -label "On Local" \
        -command "help_local .help_local" -under 3
 
    tixForm $w.file
    tixForm $w.help -right -1
 
    return $w
}

# create local2 menu bar
proc MkLocal2Menu {top} { 

    set w [frame $top.localf2 -bd 2 -relief raised]
 
    menubutton $w.file -menu $w.file.m -text File -underline 0
    menubutton $w.help -menu $w.help.m -text Help -underline 0
 
    menu $w.file.m
    $w.file.m add command -label "Dismiss" -command "destroy $top" \
	 -underline 1

    menu $w.help.m
    $w.help.m add command -under 0  -label "On Local" \
        -command "help_local .help_local" -under 3

    tixForm $w.file
    tixForm $w.help -right -1

    return $w
}

# create options window menu bar
proc MkOptionsMenu {top} {

    set w [frame $top.f1 -bd 2 -relief raised]
 
    menubutton $w.file -menu $w.file.om -text File -underline 0
    menubutton $w.help -menu $w.help.om -text Help -underline 0
 
    menu $w.file.om
    $w.file.om add command -label "Dismiss" -command "destroy $top"  \
	-underline 0
    $w.file.om add command -label "Reset" -command "reset_option"  \
	-underline 0
    $w.file.om add command -label "Apply" -command "apply_option" \
	 -underline 0
 
    menu $w.help.om
    $w.help.om add command -under 0  -label "On Options" \
        -command "help_option .help_option" -under 3
 
    tixForm $w.file
    tixForm $w.help -right -1
 
    return $w
}

# save network_type selection into global array 
proc SetNetwork {top args} {

   	global isdn_list
	global isdn0
	global isdn1
	global isdn2
	global isdn3
	global isdn4
	global isdn5
	global isdn6
	global isdn7
	global isdn8
	global isdn9
	global isdn10
	global isdn11
    	set network  [$top cget -value]
    	set ${isdn_list}(switch_type) $network
}

# create Network Combo Box
proc MkNetworkCombo {top} {
    
    global isdntool
    global isdn_list
    global isdn0
    global isdn1
    global isdn2
    global isdn3
    global isdn4
    global isdn5
    global isdn6
    global isdn7
    global isdn8
    global isdn9
    global isdn10
    global isdn11

    set w $top
    set name [tixOptionName $w]
    option add *$name*TixCombobox*label.width 15
    option add *$name*TixCombobox*label.anchor e
    option add *$name*TixCombobox*entry.width 14


    # create a combo box 
    tixCombobox $w.static   -label "Select a network: " \
        -editable false  \
	-command "SetNetwork $w.static"  \
	-options {
            		entry.width    8
            		listbox.height 11 
         }

    # save widget into global isdntool widget array
    set isdntool(network) $w.static

    # populate the combo box with the various network types
    $isdntool(network) insert end au1
    $isdntool(network) insert end vn6
    $isdntool(network) insert end tr6
    $isdntool(network) insert end ntt
    $isdntool(network) insert end bt2
    $isdntool(network) insert end dms 
    $isdntool(network) insert end 5ess
    $isdntool(network) insert end ni2
    $isdntool(network) insert end etsi
    $isdntool(network) insert end swd-etsi
    $isdntool(network) insert end hkt

    # nested sets are used to retrieve the array value	(tricky...)
    set type  [set ${isdn_list}(switch_type)]	

    switch -exact $type {
	"au1"	{ $isdntool(network) pick 0 }
	"vn6"   { $isdntool(network) pick 1 }
	"tr6"   { $isdntool(network) pick 2 }
	"ntt"   { $isdntool(network) pick 3 }
	"bt2"   { $isdntool(network) pick 4 }
	"dms"   { $isdntool(network) pick 5 }
	"5ess"  { $isdntool(network) pick 6 }
	"ni2"   { $isdntool(network) pick 7 } 
	"etsi"  { $isdntool(network) pick 8 }
	"swd-etsi"  { $isdntool(network) pick 9 }
	"hkt"  { $isdntool(network) pick 10 }
	default { 
		set ${isdn_list}(switch_type) "ni2"
		$isdntool(network) pick 7
		#  puts "network_type is missing"
		#  puts "isdntool is exiting...."
		#  exit 1 
		}
    }

    tixForm $isdntool(network) -left 0
}

 
#
# create local screen B
# invoked when pressing the "local"
#
proc MkLocal2Screen { w args } {

    	if { [winfo exists  $w.local2] == 1 } {
       		return
    	}
	
	global isdntool
    	global isdn_list 
	global isdn0
	global isdn1
	global isdn2
	global isdn3
	global isdn4
	global isdn5
	global isdn6
	global isdn7
	global isdn8
	global isdn9
	global isdn10
	global isdn11
    	
	toplevel $w.local2
	set isdntool(toplevel_local2) $w.local2

    	wm title $w.local2 {Local Addresses - Profile B}
    	wm iconname $w.local2 {local B}
    	wm iconbitmap $w.local2 @ppm/logo.bmp

    	# create menubar widgets(s)

    	set frame3 [MkLocal1Menu       $w.local2]
    	pack $frame3 -side top    -fill x


	#
	frame $w.local2.entry -relief raised -borderwidth 1
	pack $w.local2.entry -side top  -fill x

	foreach i {5 6 7 8} {
		frame $w.local2.entry.$i -borderwidth 1 -relief raised
		pack $w.local2.entry.$i -in $w.local2.entry -side top -fill x
        	label $w.local2.entry.$i.local2 -text "local addr [expr $i-4]:" -anchor e
        	entry $w.local2.entry.$i.entry1 -width 32 -relief sunken -textvariable ${isdn_list}(la$i)
        	label $w.local2.entry.$i.sub -text "sub addr [expr $i-4]:" -anchor e
        	entry $w.local2.entry.$i.entry2 -width 20 -relief sunken -textvariable ${isdn_list}(lsa$i)
        	pack $w.local2.entry.$i.local2 $w.local2.entry.$i.entry1 \
			-in $w.local2.entry.$i -side left 
        	pack $w.local2.entry.$i.sub $w.local2.entry.$i.entry2 \
			-in $w.local2.entry.$i -side left
	}
	foreach i {5 6 7 8} {
		set isdntool(local_address$i)   $w.local2.entry.$i.entry1
		set isdntool(losub_address$i)   $w.local2.entry.$i.entry2
	}
	frame $w.local2.select -borderwidth 1
	pack $w.local2.select -side top -fill both -in $w.local2
	#button $w.local2.select.reset -text reset -command {}
	button $w.local2.select.dismiss -text dismiss -command "destroy $w.local2"
	pack $w.local2.select.dismiss -side left -fill x \
		-expand true -in $w.local2.select

}

# create local screen A
# invoked when pressing the "local"
proc MkLocal1Screen { w args } {

  	if { [winfo exists  $w.local1] == 1 } {
        	return
  	}
	
	global isdntool
	global isdn_list
	global isdn0
	global isdn1
	global isdn2
	global isdn3
	global isdn4
	global isdn5
	global isdn6
	global isdn7
	global isdn8
	global isdn9
	global isdn10
	global isdn11

	toplevel $w.local1
	set isdntool(toplevel_local1) $w.local1

	wm title $w.local1 {Local Addresses - Profile A}
	wm iconname $w.local1 {local A}
 	wm iconbitmap $w.local1 @ppm/logo.bmp

	# create menubar widgets(s)

	set frame4 [MkLocal2Menu       $w.local1]
	pack $frame4 -side top    -fill x


	#
	frame $w.local1.entry -relief raised -borderwidth 1
	pack $w.local1.entry -side top  -fill x

	foreach i {1 2 3 4} {
		frame $w.local1.entry.$i -borderwidth 1 -relief raised
		pack $w.local1.entry.$i -in $w.local1.entry -side top -fill x
        	label $w.local1.entry.$i.local1 -text "local addr $i:" -anchor e
        	entry $w.local1.entry.$i.entry1 -width 32 -relief sunken -textvariable ${isdn_list}(la$i)
        	label $w.local1.entry.$i.sub -text "sub addr $i:" -anchor e
        	entry $w.local1.entry.$i.entry2 -width 20 -relief sunken -textvariable ${isdn_list}(lsa$i)
        	pack $w.local1.entry.$i.local1 $w.local1.entry.$i.entry1 \
			-in $w.local1.entry.$i -side left 
        	pack $w.local1.entry.$i.sub $w.local1.entry.$i.entry2 \
			-in $w.local1.entry.$i -side left
	}
	foreach i {1 2 3 4} {
		set isdntool(local_address$i)   $w.local1.entry.$i.entry1
		set isdntool(losub_address$i)   $w.local1.entry.$i.entry2
	}
	frame $w.local1.select -borderwidth 1
	pack $w.local1.select -side top -fill both -in $w.local1
	#button $w.local1.select.reset -text reset -command {}
	button $w.local1.select.dismiss -text dismiss -command "destroy $w.local1"
	pack $w.local1.select.dismiss -side left -fill x \
		-expand true -in $w.local1.select
}


proc create_options {w args} {

  if { [winfo exists  $w] == 1 } {
	wm deiconify $w
	return
  }
	global isdntool
	# init local toplevel pointers
	set isdntool(toplevel_local1) 0
	set isdntool(toplevel_local2) 0
	global isdn_list
	global tmp_list
	global isdn0
	global isdn1
	global isdn2
	global isdn3
	global isdn4
	global isdn5
	global isdn6
	global isdn7
	global isdn8
	global isdn9
	global isdn10
	global isdn11
	set isdn_list isdn0
	set tmp_list isdn0
	toplevel $w
	wm title $w {isdn configuration options}
	wm positionfrom $w ""
	wm sizefrom $w ""
	wm minsize $w 50 50
	wm iconname $w "options"
 	wm iconbitmap $w @ppm/logo.bmp

	# create menubar widgets(s)

	set frame1 [MkOptionsMenu	$w]
	pack $frame1 -side top    -fill x

	# right frame 
	frame $w.right
	pack $w.right -side right

	# left frame
	frame  $w.left  -relief raised
	pack $w.left -side left -fill both

	# create Network widget 
 
	frame $w.n1
	pack $w.n1 -in $w.right -fill both -expand true

	set name [tixOptionName $w.n1]
	option add *$name*TixLabelFrame*label.padX 4
 
	tixLabelFrame $w.n1.nt -label "Network Type"
 
	MkNetworkCombo   [$w.n1.nt subwidget frame]
	tixForm $w.n1.nt -top 0 -left 0 


	# Create Profile A

	frame $w.fi1
	pack $w.fi1 -in $w.right -fill y


	set name [tixOptionName $w.fi1]
	option add *$name*TixLabelFrame*label.padX 4

	tixLabelFrame $w.fi1.pr1 -label "Profile A"

	MkProfileA [$w.fi1.pr1 subwidget frame ]
	tixForm $w.fi1.pr1 -top 0 -left 0  -bottom -1

	# Create Profile B

	frame $w.fi2
	pack $w.fi2 -in $w.right -fill y


	set name [tixOptionName $w.fi2]
	option add *$name*TixLabelFrame*label.padX 4
 	
	tixLabelFrame $w.fi2.pr2 -label "Profile B"

	MkProfileB [$w.fi2.pr2 subwidget frame ]
	tixForm $w.fi2.pr2 -top 0 -left 0  -bottom -1

	# Create the physical interface scroll list

 	set name [tixOptionName $w.left]
 	option add *$name*TixLabelFrame*label.padX 4

 	tixLabelFrame $w.left.sls -label "Physical Interfaces"

 	MkSList   [$w.left.sls subwidget frame]
 	tixForm $w.left.sls -top 0 -left 0  -bottom -1


	# Create Control buttons
 
	frame $w.apply 
	pack $w.apply -in $w.right -side bottom -expand true -fill x

	# create selection button (apply/reset/dismiss)  widget
 
	button $w.apply.dismiss -text dismiss -command " destroy $w"
	button $w.apply.reset -text reset -command "reset_option"
	button $w.apply.apply -text apply -command "apply_option"
	pack $w.apply.dismiss $w.apply.reset $w.apply.apply \
		-in $w.apply -side left -fill both -expand true

	update idletasks

}

#
# procedure to create a TixScrollList
#
proc MkSList {w} {

        global isdntool
	global isdn_list
        global isdnlist0
        global isdnlist1
        global isdnlist2
        global isdnlist3
        global isdnlist4
        global isdnlist5
        global isdnlist6
        global isdnlist7
        global isdnlist8
        global isdnlist9
        global isdnlist10
        global isdnlist11
        global isdn0
        global isdn1
        global isdn2
        global isdn3
        global isdn4
        global isdn5
        global isdn6
        global isdn7
        global isdn8
        global isdn9
        global isdn10
        global isdn11


	frame $w.slist

	set list [tixScrolledListbox $w.slist.list -scrollbar auto]
	place $list -x 10 -y 10  -width 115 -height 360 

	pack propagate $w.slist 0
	pack $w.slist -expand yes -fill both

	set iid 0
	while {[info exists isdnlist$iid] == 1} {
        	incr iid 1
	}
	for {set i 0 } {$i < $iid } {incr i 1} {
		$list subwidget listbox insert end " isdn_$i"
		update
	}
	#$list subwidget listbox activate 0
	#puts $list
	bind [ $list subwidget listbox ] <Button-1> { 
		do_bind %W %y 
	}
}

#
#
#
proc tixOptionName {w} {
    	return [string range $w 1 [expr [string length $w]-1]]
}

# this proc is not used!
proc MkSelect {w} {
    set name [tixOptionName $w]
    option add *$name*TixSelect*label.anchor c
    option add *$name*TixSelect*orientation vertical
    option add *$name*TixSelect*labelSide left
 
    tixSelect $w.sel1 -label "cli" -allowzero true -radio true
    tixSelect $w.sel2 -label "force56" -allowzero true -radio true
 
    $w.sel1 add sleep -text cli
    $w.sel1 add sleep -text force56
     
    pack $w.sel1 $w.sel2 -side left -padx 5 -pady 3 -fill x
}

# create B profile
proc MkProfileB {top} {

global isdntool
global isdn_list
global isdn0
global isdn1
global isdn2
global isdn3
global isdn4
global isdn5
global isdn6
global isdn7
global isdn8
global isdn9
global isdn10
global isdn11

# label profile B
set w $top
# create calling number widget

frame $w.cn2
pack $w.cn2 -in $top -side top -pady 2 -anchor e
label $w.cn2.label -text "calling number:" -anchor e
entry $w.cn2.entry -width 32 -relief sunken -textvariable ${isdn_list}(cn2)
pack $w.cn2.entry $w.cn2.label -side right

set isdntool(calling_number2) $w.cn2.entry

# create subaddress widget

frame $w.sub2
pack $w.sub2 -in $top -side top -pady 2 -anchor e
label $w.sub2.label -text "sub address:" -anchor e
entry $w.sub2.entry -width 32 -relief sunken -textvariable ${isdn_list}(sa2)
pack $w.sub2.entry $w.sub2.label -side right

set isdntool(sub_address2) $w.sub2.entry

#create spid widget 

frame $w.spid2
pack $w.spid2 -in $top -side top -pady 2 -anchor e
label $w.spid2.label -text "spid :" -anchor e
entry $w.spid2.entry -width 32 -relief sunken  -textvariable ${isdn_list}(spid2)
pack $w.spid2.entry $w.spid2.label -side right

set isdntool(spid2) $w.spid2.entry

#create cli/force56/local/nai widget


frame $w.560 -relief {raised}
pack  $w.560 -in $top -side top -pady 2 -anchor e

button $w.560.menubutton6 -text "local" -relief groove -command {MkLocal2Screen .isdn_options "bogus"}

checkbutton $w.560.menubutton4 \
    -text { force56} -variable ${isdn_list}(cf562) -selectcolor lightblue -onvalue "on" -offvalue "off"
 
checkbutton $w.560.menubutton5 \
    -text { cli } -variable ${isdn_list}(cli2) -selectcolor lightblue -onvalue "on" -offvalue "off"


pack $w.560.menubutton6 $w.560.menubutton5 $w.560.menubutton4  -in $w.560 -pady 2 -side left  -fill x -anchor w

set isdntool(force562) $w.560.menubutton4
set isdntool(cli2) $w.560.menubutton5
}

# create A profile
proc MkProfileA {top} {

global isdntool
global isdn_list
global isdn0
global isdn1
global isdn2
global isdn3
global isdn4
global isdn5
global isdn6
global isdn7
global isdn8
global isdn9
global isdn10
global isdn11

# label profile A
set w $top
# create calling number widget

frame $w.cn1
pack $w.cn1 -in $top -side top -pady 2 -anchor e
label $w.cn1.label -text "calling number:" -anchor e
entry $w.cn1.entry -width 32 -relief sunken -textvariable ${isdn_list}(cn1)
pack $w.cn1.entry $w.cn1.label -side right

set isdntool(calling_number1) $w.cn1.entry

# create subaddress widget

frame $w.sub1
pack $w.sub1 -in $top -side top -pady 2 -anchor e
label $w.sub1.label -text "sub address:" -anchor e
entry $w.sub1.entry -width 32 -relief sunken -textvariable ${isdn_list}(sa1)
pack $w.sub1.entry $w.sub1.label -side right

set isdntool(sub_address1) $w.sub1.entry

#create spid widget 

frame $w.spid1
pack $w.spid1 -in $top -side top -pady 2 -anchor e
label $w.spid1.label -text "spid :" -anchor e
entry $w.spid1.entry -width 32 -relief sunken -textvariable ${isdn_list}(spid1)
pack $w.spid1.entry $w.spid1.label -side right

set isdntool(spid1) $w.spid1.entry

#create cli/force56/local/nai widget

frame $w.force56 -relief {raised}
pack  $w.force56 -in $top -side top -pady 2 -anchor e

button $w.force56.mbt3 -text "local" -relief groove -command {MkLocal1Screen .isdn_options "bogus"}

checkbutton $w.force56.mbt2 -text force56 -variable ${isdn_list}(cf561) -onvalue "on" -offvalue "off" -selectcolor lightblue
checkbutton $w.force56.mbt1 -text cli -variable ${isdn_list}(cli1) -onvalue on -offvalue "off" -selectcolor lightblue


pack $w.force56.mbt3 $w.force56.mbt1 $w.force56.mbt2  -in $w.force56 -pady 2 -side left  -fill x -anchor w

set isdntool(force561) $w.force56.mbt2
set isdntool(cli1) $w.force56.mbt1

}


#
# update all widget values on bind event
# this proc is called when the user selects a new physical interface
# by clicking on one of the NetworkComboBox entries
# 
proc do_bind { w y } {

global isdntool
global isdn_list
global isdn0
global isdn1
global isdn2
global isdn3
global isdn4
global isdn5
global isdn6
global isdn7
global isdn8
global isdn9
global isdn10
global isdn11
global tmp_list

# get current physical interface selection (index)
if {[$w curselection] == "" } {
	set isdn_list "isdn0"
	set tmp_list "isdn0"
} else {
	set isdn_list "isdn[ $w curselection]"
	set tmp_list "tmp[ $w curselection]"
}
    
# update network type
set type  [set ${isdn_list}(switch_type)]
switch -exact $type {
        "au1" 	{ $isdntool(network) pick 0 }
        "vn6" 	{ $isdntool(network) pick 1 }
        "tr6" 	{ $isdntool(network) pick 2 }
        "ntt" 	{ $isdntool(network) pick 3 }
        "bt2" 	{ $isdntool(network) pick 4 }
        "dms" 	{ $isdntool(network) pick 5 }
        "5ess" 	{ $isdntool(network) pick 6 }
        "ni2"  	{ $isdntool(network) pick 7 }
        "etsi" 	{ $isdntool(network) pick 8 }
        "swd-etsi" 	{ $isdntool(network) pick 9 }
        "hkt" 	{ $isdntool(network) pick 10 }
        default { 
		set ${isdn_list}(switch_type) "ni2"
		$isdntool(network) pick 7

		 # puts "network_type is missing"
                 # puts "isdntool is exiting...."
                 # exit 1
                }
}

# update button values

# profile A
$isdntool(calling_number1) 	config -textvariable ${isdn_list}(cn1)
$isdntool(sub_address1) 	config -textvariable ${isdn_list}(sa1)
$isdntool(spid1) 		config -textvariable ${isdn_list}(spid1)
$isdntool(force561) 		config -variable ${isdn_list}(cf561)
$isdntool(cli1) 		config -variable ${isdn_list}(cli1)

if { [winfo exists  $isdntool(toplevel_local1)] == 1 } {
$isdntool(local_address1) 	config -textvariable ${isdn_list}(la1)
$isdntool(local_address2) 	config -textvariable ${isdn_list}(la2)
$isdntool(local_address3) 	config -textvariable ${isdn_list}(la3)
$isdntool(local_address4) 	config -textvariable ${isdn_list}(la4)

$isdntool(losub_address1) 	config -textvariable ${isdn_list}(lsa1)
$isdntool(losub_address2) 	config -textvariable ${isdn_list}(lsa2)
$isdntool(losub_address3) 	config -textvariable ${isdn_list}(lsa3)
$isdntool(losub_address4) 	config -textvariable ${isdn_list}(lsa4)
}

# profile B
$isdntool(calling_number2)      config -textvariable ${isdn_list}(cn2)
$isdntool(sub_address2)         config -textvariable ${isdn_list}(sa2)
$isdntool(spid2)                config -textvariable ${isdn_list}(spid2)
$isdntool(force562)             config -variable ${isdn_list}(cf562)
$isdntool(cli2)                 config -variable ${isdn_list}(cli2)

if { [winfo exists  $isdntool(toplevel_local2)] == 1 } {
$isdntool(local_address5)       config -textvariable ${isdn_list}(la5)
$isdntool(local_address6)       config -textvariable ${isdn_list}(la6)
$isdntool(local_address7)       config -textvariable ${isdn_list}(la7)
$isdntool(local_address8)       config -textvariable ${isdn_list}(la8)

$isdntool(losub_address5)       config -textvariable ${isdn_list}(lsa5)
$isdntool(losub_address6)       config -textvariable ${isdn_list}(lsa6)
$isdntool(losub_address7)       config -textvariable ${isdn_list}(lsa7)
$isdntool(losub_address8)       config -textvariable ${isdn_list}(lsa8)
}
 
update idletasks
}
