#
#ident  "@(#)isdntool_te.tcl	1.26 96/03/07 SMI"
#
# Copyright (c) 1993 by Sun Microsystems, Inc.
#
# ISDN configuration tool

set max_address 32
set max_subaddress 20
set max_spid 20

proc apply_success { } {

	set w .apply_success
        if {[winfo exists $w] == 1} {
                wm deiconify $w
                return
        }
        toplevel $w
        wm title $w {apply_success}
        wm iconbitmap $w @ppm/logo.bmp

	text $w.text -bd 2 -width 30 -height 3 \
		-font -Adobe-times-medium-r-normal--*-180*
	$w.text insert end {Configurations has been applied!}

        pack $w.text -side top -fill both -expand true
        button $w.dismiss -text Dismiss -command "destroy $w"
        pack $w.dismiss -side bottom -fill x
	update idletasks	
	return 

}
	

proc check_local_for_ni2 {} {
	global isdn0
	global isdn1
	global isdn2
	global isdn3
	global isdn4
	global isdn5
	global isdn6
	global isdn7
	global isdn8
	global isdn9
	global isdn10
	global isdn11
	global isdn_list
	set match1 1
	set match2 1

        set w .ni2_error
        if {[winfo exists $w] == 1} {
                wm deiconify $w
                return
        }
        toplevel $w
        wm title $w {error}
        wm iconbitmap $w @ppm/logo.bmp

        text $w.texterr -bd 2 \
                -font -Adobe-times-medium-r-normal--*-180*
	
	if {[string length [set ${isdn_list}(cn2)]] != 0 } {
	    if {![string match [set ${isdn_list}(cn2)] "nil"] } {
		foreach i {1 2 3 4} { 
			set jk [string compare [set ${isdn_list}(cn1)] \
						[set ${isdn_list}(la$i)]]
			set match1 [expr $match1 && $jk]
		}
		foreach i {5 6 7 8} {
			set jk [string compare [set ${isdn_list}(cn2)] \
						[set ${isdn_list}(la$i)]]
			set match2 [expr $match2 && $jk]
		}
	    }
	} else {
		destroy $w
		return 0
	}

	if {$match1 || $match2} {
		$w.texterr insert end \
{For NI2 switch type with two calling profiles, Please add Your 
Calling Number in Profile A/B to one of the four local number entries inside
the local-address/local-sub-address screen for both Profile A/B.

Please use "local" button inside Profile A/B to pop-up the the local-address/
local-sub-address screen for each profile.

Your "apply" command has not been succefully write back, please fix the above
error and try again.  }
	
        	pack $w.texterr -side top -fill both -expand true
        	button $w.start_dismiss -text Dismiss -command "destroy $w"
        	pack $w.start_dismiss -side bottom -fill x
		update idletasks	
		return 1
	} else {
		destroy $w
		return 0
	}
}

proc check_number { } {
	global isdn0
	global isdn1
	global isdn2
	global isdn3
	global isdn4
	global isdn5
	global isdn6
	global isdn7
	global isdn8
	global isdn9
	global isdn10
	global isdn11
	global isdn_list

        set w .p_error
        if {[winfo exists $w] == 1} {
                wm deiconify $w
                return
        }
	set error 0
        toplevel $w
        wm title $w {error}
        wm iconbitmap $w @ppm/logo.bmp

        text $w.texterr -bd 2 \
                -font -Adobe-times-medium-r-normal--*-180*
	$w.texterr insert end "Only digits, nil, or empty strings are allowed in the following field : \n"
	$w.texterr insert end "--------------------------------------------------\n"

	if {![regexp {^[0-9nil]+$} [set ${isdn_list}(cn1)]] && \
		[string length [set ${isdn_list}(cn1)]] != 0 } {
		$w.texterr insert end "Profile A, calling number\n"
		set error 1
	}
	if {![regexp {^[0-9nil]+$} [set ${isdn_list}(cn2)]] &&  \
		[string length [set ${isdn_list}(cn2)]] != 0 } {
		$w.texterr insert end "Prifile B, calling number\n"
		set error 1
	}
	if {![regexp {^[0-9nil\0 ]+$} [set ${isdn_list}(sa1)]] && \
		[string length [set ${isdn_list}(sa1)]] != 0 } {
		$w.texterr insert end "Profile A, sub address\n"
		set error 1
	}
	if {![regexp {^[0-9nil\0 ]+$} [set ${isdn_list}(sa2)]] && \
		[string length [set ${isdn_list}(sa2)]] != 0 } {
		$w.texterr insert end "Profile B, sub address\n"
		set error 1
	}
	if {![regexp {^[0-9nil\0 ]+$} [set ${isdn_list}(spid1)]] && \
		[string length [set ${isdn_list}(spid1)]] != 0 } {
		$w.texterr insert end "Profile A, spid\n"
		set error 1
	}
	if {![regexp {^[0-9nil\0 ]+$} [set ${isdn_list}(spid2)]] && \
		[string length [set ${isdn_list}(spid2)]] != 0 } {
		$w.texterr insert end "Profile B, spid\n"
		set error 1
	}
	foreach i {1 2 3 4} {
		if {![regexp {^[0-9nil\0 ]+$} [set ${isdn_list}(la$i)]] && \
			[string length [set ${isdn_list}(la$i)]] != 0 } {
			$w.texterr insert end "Profile A, local addr $i \n"
			set error 1
		}
		if {![regexp {^[0-9nil\0 ]+$} [set ${isdn_list}(lsa$i)]] && \
			[string length [set ${isdn_list}(lsa$i)]] != 0 } {
			$w.texterr insert end "Profile A, local sub address $i \n"
			set error 1
		}
	}
	foreach i {5 6 7 8} {
		if {![regexp {^[0-9nil\0 ]+$} [set ${isdn_list}(la$i)]] && \
			[string length [set ${isdn_list}(la$i)]] != 0 } {
			$w.texterr insert end "Profile B, local address [expr $i - 4] \n"
			set error 1
		}
		if {![regexp {^[0-9nil\0 ]+$} [set ${isdn_list}(lsa$i)]] && \
			[string length [set ${isdn_list}(lsa$i)]] != 0 } {
			$w.texterr insert end "Prifile B, local sub address [expr $i - 4] \n"
			set error 1
		}
	}

	
	if {$error == 0 } {
		destroy .p_error
		return 0
	} 
        pack $w.texterr -side top -fill both -expand true
        button $w.start_dismiss -text Dismiss -command "destroy $w"
        pack $w.start_dismiss -side bottom -fill x
	update idletasks	
	return 1

}
proc trimaddr { addr } {
	 global max_address
	 set lenaddr [string length $addr]
	 if { $lenaddr > $max_address } {  
              set address [string range $addr 0 [expr $max_address-1]]
	      return $address
         }  else {
	      return $addr
	 }
}

proc trimsub { sub } { 
         global max_subaddress 
	 set lensub [string length $sub]
         if { $lensub > $max_subaddress } {  
              set subaddress [string range $sub 0 [expr $max_subaddress-1]]
              return $subaddress
         }  else {
              return $sub
         }
}

proc trimspid { spid } { 
         global max_spid 
	 set lenspid [string length $spid]
         if { $lenspid > $max_spid } {  
              set sspid [string range $spid 0 [expr $max_spid-1]]
              return $sspid
         }  else {
              return $spid
         }
}


proc apply_option { } {
	global currlist
	global isdn0
	global isdn1
	global isdn2
	global isdn3
	global isdn4
	global isdn5
	global isdn6
	global isdn7
	global isdn8
	global isdn9
	global isdn10
	global isdn11
	global isdn_list
	set profileb 1
	switch -exact $isdn_list {
		isdn0 { set of 0 }
		isdn1 { set of 1 }
		isdn2 { set of 2 }
		isdn3 { set of 3 }
		isdn4 { set of 4 }
		isdn5 { set of 5 }
		isdn6 { set of 6 }
		isdn7 { set of 7 }
		isdn8 { set of 8 }
		isdn9 { set of 9 }
		isdn10 { set of 10}
		isdn11 { set of 11}
		default { 
			  puts "Too many interfaces configured, aborting"
			  exit 1
		}
	}
	if {[check_number ]} {
		return;
	}

	if {[string match [set ${isdn_list}(switch_type)] "ni2"]} {
		if {[check_local_for_ni2]} {
			return;
		}
	}


	if { ![file exists /etc/opt/SUNWisdn/te/$of] } {
		puts "cannot find isdn configuration file!"
		puts "please check your isdn installation"
		return
	}
        # set country based on switch_type
	set type [set ${isdn_list}(switch_type)]

	switch -exact $type {
		dms 	{ set ${isdn_list}(country) usa 	}
		5ess 	{ set ${isdn_list}(country) usa 	}
		ni2 	{ set ${isdn_list}(country) usa 	}
		ntt	{ set ${isdn_list}(country) japan 	}
		bt2	{ set ${isdn_list}(country) uk 		}
		vn6	{ set ${isdn_list}(country) france 	}
		tr6	{ set ${isdn_list}(country) germany 	}
		au1	{ set ${isdn_list}(country) australia 	}
		etsi	{ set ${isdn_list}(country) europe 	}
		swd-etsi { set ${isdn_list}(country) sweden	}
		hkt	{ set ${isdn_list}(country) hong_kong	}
		default { 
			  puts "Invalid switch type, aborting"
			  exit 1
			}
        }

	exec mv /etc/opt/SUNWisdn/te/$of /etc/opt/SUNWisdn/te/$of.bak
	set te [open /etc/opt/SUNWisdn/te/$of {RDWR CREAT}]

	puts $te "# SuISDN 1.0.2 configuration file"
	puts $te "#"
	puts $te "# This configuration file is automatically generated by isdntool"
	puts $te "#"
	puts $te "# isdn.cf"
	puts $te "#---------------------------------------------------------------------------"
	puts $te "isdn_config             # ISDN configuration\n"
	puts $te "#---------------------------------------------------------------------------"
	puts $te "## Warning: dms, 5ess (multipoint) and ni2 switch types may support"
	puts $te "# 1DN, 1DN+1SPID or 2DNs +2SPIDs. Therefore, two cc_profiles and"
	puts $te "# two ns_profiless may be configured over the same dl and physical interface."
	puts $te "# Other switch types must always have a single cc_profile and a"
	puts $te "# single ns_profile configured."
	puts $te "#---------------------------------------------------------------------------"
	puts $te "cc_config               # Call Control parameters -- "
	puts $te "#---------------------------------------------------------------------------"
	puts $te "\n"
	puts $te "# about force 56:"
	puts $te "# A 56Kb outgoing call may appear as a 64Kb call on the incoming side,"
	puts $te "# due to configuration problems in the network. If this error occurs,"
	puts $te "# set the cc_force56 option to on to enforce a 56K baud rate."
	puts $te "\n"
	puts $te "# about local addrress:"
	puts $te "# If present, the incoming call called address will be checked against"
	puts $te "# the specified local address(es). If there is no match, the incoming call"
	puts $te "# will be rejected. Up to 4 local addresses are supported per nai."
	puts $te "#"
	puts $te "# In a NI-1/2 multipoint configuration, if the Sun is configured with"
	puts $te "# 2 profiles (A & B), each profile must have a local address configured"
	puts $te "# and equal to the calling number. The local address will be used to"
	puts $te "# filter calls which do not have an Endpoint ID."
	puts $te "\n"
	puts $te "# If connected to a 1TR6 Multipoint switch (Germany), you must set the"
	puts $te "# cc_calling_nb and cc_local_nb to the EAZ value assigned by your ISDN provider."
	puts $te "# The EAZ (1-9) is used to differentiate several devices connected to the"
	puts $te "# same multipoint line. EAZ (0) is used to broadcast an incoming call to all"
	puts $te "# devices. EAZ does not apply to 1TR6 point-to-point."
	puts $te "\n"
	puts $te "# PROFILE_A"
	puts $te "cc_profile		A"


	set cn1 [set ${isdn_list}(cn1)]
	set jk [string length $cn1]
  	if { $jk == 0 } {
		puts $te "#cc_calling_nb          |>calling-number-or-EAZ<|"
	} else {
		puts $te "cc_calling_nb             [trimaddr $cn1]"
	}
	puts $te "\n"
	# sa1
	set sa1 [set ${isdn_list}(sa1)]
	set jk [string length $sa1]
	if { $jk == 0 } {
		puts $te "#cc_calling_sub_add   |>calling-sub-add<|"
	} else {
		puts $te "cc_calling_sub_add		[trimsub $sa1]"
	}
	puts $te "\n"
	# la1
	set la1 [set ${isdn_list}(la1)]
	set jk [string length $la1]
	if { $jk == 0 } {
		puts $te "#cc_local_nb            |>local-nb-or-EAZ-or-calling-nb<|            # optional" 
	} else {
		puts $te "cc_local_nb			[trimaddr $la1]"
	}
	# lsa1
	set lsa1 [set ${isdn_list}(lsa1)]
	set jk [string length $lsa1]	
	if { $jk == 0 } {
		puts $te "#cc_local_sub_add       |>local-sub-add<|       # optional"
	} else {
		puts $te "cc_local_sub_add		[trimsub $lsa1]"
	}
	puts $te "\n"
	# la2
	set la2 [set ${isdn_list}(la2)]
	set jk [string length $la2]
	if { $jk == 0 } {
		puts $te "#cc_local_nb            |>local-nb<|            # optional" 
	} else {
		puts $te "cc_local_nb			[trimaddr $la2]"
	}
	# lsa2
	set lsa2 [set ${isdn_list}(lsa2)]
	set jk [string length $lsa2]	
	if { $jk == 0 } {
		puts $te "#cc_local_sub_add       |>local-sub-add<|       # optional"
	} else {
		puts $te "cc_local_sub_add		[trimsub $lsa2]"
	}
	# la3
	set la3 [set ${isdn_list}(la3)]
	set jk [string length $la3]
	if { $jk == 0 } {
		puts $te "#cc_local_nb            |>local-nb<|            # optional" 
	} else {
		puts $te "cc_local_nb			[trimaddr $la3]"
	}
	# lsa3
	set lsa3 [set ${isdn_list}(lsa3)]
	set jk [string length $lsa3]	
	if { $jk == 0 } {
		puts $te "#cc_local_sub_add       |>local-sub-add<|       # optional"
	} else {
		puts $te "cc_local_sub_add		[trimsub $lsa3]"
	}
	# la4
	set la4 [set ${isdn_list}(la4)]
	set jk [string length $la4]
	if { $jk == 0 } {
		puts $te "#cc_local_nb            |>local-nb<|            # optional" 
	} else {
		puts $te "cc_local_nb			[trimaddr $la4]"
	}
	# lsa4
	set lsa4 [set ${isdn_list}(lsa4)]
	set jk [string length $lsa4]	
	if { $jk == 0 } {
		puts $te "#cc_local_sub_add       |>local-sub-add<|       # optional"
	} else {
		puts $te "cc_local_sub_add		[trimsub $lsa4]"
	}
	# force56
	set cf561 [set ${isdn_list}(cf561)]
	set jk [string length $cf561]
	if { $jk == 0 } {
		puts $te "#cc_force56             on"
	} else {
		puts $te "cc_force56			$cf561"
	}
	# cli
	set cli1 [set ${isdn_list}(cli1)]
	set jk [string length $cli1]
	if { $jk == 0 } {
		puts $te "#cc_cli			on"
	} else {
		puts $te "cc_cli				$cli1"
	}
	puts $te "\n"
	# country
	puts $te "cc_na_country		[set ${isdn_list}(country)]	# australia france germany japan uk europe sweden "
	#switch type
	set type [set ${isdn_list}(switch_type)]
	if {$type == "swd-etsi"} {
		set type "etsi"
	}	
	puts $te "cc_na_operator		$type	# au1 vn2 tr6 ntt etsi dms 5ess ni2"
	puts $te "\n"
	puts $te "#---------------------------------------------------------------------------"
	puts $te "# PROFILE_B     -- not needed for att-ptp or non-US switch types"	
	puts $te "\n"
	set cn2 [set ${isdn_list}(cn2)]
	set jk [string length $cn2]
  	if { $jk == 0 } {
		puts $te "#cc_profile		B"
		puts $te "#cc_calling_nb	|>calling-number<|"
		puts $te "\n"
		puts $te "#cc_calling_sub_add     |>calling-sub-add<|"
		puts $te "\n"
		puts $te "#cc_local_nb            |>local-nb<|            # optional"
		puts $te "#cc_local_sub_add       |>local-sub-add<|       # optional"
		puts $te "\n"
		puts $te "#cc_local_nb            |>local-nb<|            # optional"
		puts $te "#cc_local_sub_add       |>local-sub-add<|       # optional"
		puts $te "#cc_local_nb            |>local-nb<|            # optional"
		puts $te "#cc_local_sub_add       |>local-sub-add<|       # optional"
		puts $te "#cc_local_nb            |>local-nb<|            # optional"
		puts $te "#cc_local_sub_add       |>local-sub-add<|       # optional"
		puts $te "#cc_force56             on"
		puts $te "#cc_cli                 on"
		puts $te "\n"
		puts $te "#cc_na_country          usa	# australia france germany japan uk europe sweden"
		puts $te "#cc_na_operator         ni2     # au1 vn2 tr6 ntt etsi dms 5ess ni2"
		set profileb 0
	} else {
		puts $te "cc_profile		B"
		puts $te "cc_calling_nb		[trimaddr $cn2]"
	}
	puts $te "\n"
	# sa1
if {$profileb == 1} {
	set sa2 [set ${isdn_list}(sa2)]
	set jk [string length $sa2]
	if { $jk == 0 } {
		puts $te "#cc_calling_sub_add     |>calling-sub-add<|"
	} else {
		puts $te "cc_calling_sub_add		[trimsub $sa2]"
	}
	puts $te "\n"
	# la5
	set la5 [set ${isdn_list}(la5)]
	set jk [string length $la5]
	if { $jk == 0 } {
		puts $te "#cc_local_nb            |>local-nb<|            # optional" 
	} else {
		puts $te "cc_local_nb		[trimaddr $la5]"
	}
	# lsa5
	set lsa5 [set ${isdn_list}(lsa5)]
	set jk [string length $lsa5]
	if { $jk == 0 } {
		puts $te "#cc_local_sub_add       |>local-sub-add<|       # optional"
	} else {
		puts $te "cc_local_sub_add		[trimsub $lsa5]"
	}
	puts $te "\n"
	# la6
	set la6 [set ${isdn_list}(la6)]
	set jk [string length $la6]
	if { $jk == 0 } {
		puts $te "#cc_local_nb            |>local-nb<|            # optional" 
	} else {
		puts $te "cc_local_nb		[trimaddr $la6]"
	}
	# lsa6
	set lsa6 [set ${isdn_list}(lsa6)]
	set jk [string length $lsa6]
	if { $jk == 0 } {
		puts $te "#cc_local_sub_add       |>local-sub-add<|       # optional"
	} else {
		puts $te "cc_local_sub_add		[trimsub $lsa6]"
	}
	# la7
	set la7 [set ${isdn_list}(la7)]
	set jk [string length $la7]
	if { $jk == 0 } {
		puts $te "#cc_local_nb            |>local-nb<|            # optional" 
	} else {
		puts $te "cc_local_nb		[trimaddr $la7]"
	}
	# lsa7
	set lsa7 [set ${isdn_list}(lsa7)]
	set jk [string length $lsa7]
	if { $jk == 0 } {
		puts $te "#cc_local_sub_add       |>local-sub-add<|       # optional"
	} else {
		puts $te "cc_local_sub_add		[trimsub $lsa7]"
	}
	# la8
	set la8 [set ${isdn_list}(la8)]
	set jk [string length $la8]
	if { $jk == 0 } {
		puts $te "#cc_local_nb            |>local-nb<|            # optional" 
	} else {
		puts $te "cc_local_nb		[trimaddr $la8]"
	}
	# lsa8
	set lsa8 [set ${isdn_list}(lsa8)]
	set jk [string length $lsa8]
	if { $jk == 0 } {
		puts $te "#cc_local_sub_add       |>local-sub-add<|       # optional"
	} else {
		puts $te "cc_local_sub_add		[trimsub $lsa8]"
	}
	# force56
	set cf562 [set ${isdn_list}(cf562)]
	set jk [string length $cf562]
	if { $jk == 0 } {
		puts $te "#cc_force56             on"
	} else {
		puts $te "cc_force56			$cf562"
	}
	# cli
	set cli2 [set ${isdn_list}(cli2)]
	set jk [string length $cli2]
	if { $jk == 0 } {
		puts $te "#cc_cli			on"
	} else {
		puts $te "cc_cli			$cli2"
	}
	puts $te "\n"
	# country
	puts $te "cc_na_country		[set ${isdn_list}(country)]	# australia france germany japan uk europe sweden"
	# switch type
	set type [set ${isdn_list}(switch_type)]
	if {$type == "swd-etsi"} {
		set type "etsi"
	}	
	puts $te "cc_na_operator		$type	# au1 vn2 tr6 ntt etsi dms 5ess ni2"
#end of profileb
}
#end of profileb
	puts $te "\n"
	puts $te "#"
	puts $te "# Note: ns_spid should be commented out for non US switch types."
	puts $te "#"
	puts $te "#---------------------------------------------------------------------------"
	puts $te "ns_config               # Network Signalling parameters (Q.931)"
	puts $te "#---------------------------------------------------------------------------"
	puts $te "ns_profile		A"
	#spid
	set spid1 [set ${isdn_list}(spid1)]
	set jk [string length $spid1]
	if { $jk == 0 } {
		puts $te "ns_spid                 |>spid-A-or-nil<|	# US only"
	} else {
		puts $te "ns_spid			[trimspid $spid1]"
	}
	puts $te "\n"
	puts $te "#---------------------------------------------------------------------------"
	puts $te "# PROFILE_B             -- not needed for att-ptp or non-US switch types"
	puts $te "\n"
	set cn2 [set ${isdn_list}(cn2)]
	set jk [string length $cn2]
	if {$jk ==0} {
		puts $te "#ns_profile		B"
		puts $te "#ns_spid		|>spid-B-or-nil<|	# US only"
	} else {
		set spid2 [set ${isdn_list}(spid2)]
		puts $te "ns_profile		B"
		puts $te "ns_spid		[trimspid $spid2]"
	}
	puts $te "\n"
	puts $te "#---------------------------------------------------------------------------"
	puts $te " dl_config               # Data-Link parameters  (Q.921/LAPD)"
	puts $te "#---------------------------------------------------------------------------"
	puts $te "\n"
	set ctry [set ${isdn_list}(country)]
	puts $te "# PLEASE comment out the following lines for non-US switch types."
	puts $te "# BEGIN US switch specific parameters  (DMS, AT&T, NI-1/2)"
if {$ctry == "usa"} {
	puts $te "\n"
	puts $te "dl_tei_time_assignment  DL_TEI_TIME_ASSIGN_USA"
	puts $te "dl_tei_time_removal     DL_TEI_TIME_REMOVAL_USA"
	puts $te "\n"
	puts $te "dl_sapi                 0       # SIG"
	set cn2 [set ${isdn_list}(cn2)]
	set jk [string length $cn2]
	if {$jk ==0} {
		puts $te "dl_dlcep_nb             2       # if 2DNs/2SPIDS configured, set to 3 (ni1/2, dms, att-mtp)"	
	} else {
		puts $te "dl_dlcep_nb             3       # if 2DNs/2SPIDS configured, set to 3 (ni1/2, dms, att-mtp)"	
	}
	puts $te "                                # if switch is att-ptp or 1DN/1SPID configured, set to 2"
	puts $te "                                # if sharing mpt-line with a phone, set to 2 (mixed voice-data)"
	puts $te "                                #"
	puts $te "dl_rc_nb                1000    # N202 retry count to activate layer 2"
	puts $te "\n"
	puts $te "dl_sapi                 63      # MGT"
	set cn2 [set ${isdn_list}(cn2)]
	set jk [string length $cn2]
	if {$jk ==0} {
		puts $te "dl_dlcep_nb             2       # if 2DNs/2SPIDS configured, set to 3 (ni1/2, dms, att-mtp)"
	} else {
		puts $te "dl_dlcep_nb             3       # if 2DNs/2SPIDS configured, set to 3 (ni1/2, dms, att-mtp)"
	}
	puts $te "                                # if switch is att-ptp or 1DN/1SPID configured, set to 2"
	puts $te "                                # if sharing mpt-line with a phone, set to 2 (mixed voice-data)"
	puts $te "                                #"
	puts $te "dl_rc_nb                1000    # N202 retry count to activate layer 2"
} else {
# country is not usa
	puts $te "\n"
	puts $te "#dl_tei_time_assignment  DL_TEI_TIME_ASSIGN_USA"
	puts $te "#dl_tei_time_removal     DL_TEI_TIME_REMOVAL_USA"
	puts $te "\n"
	puts $te "#dl_sapi                 0       # SIG"
	puts $te "#dl_dlcep_nb             3       # if 2DNs/2SPIDS configured, set to 3 (ni1/2, dms, att-mtp)"
	puts $te "                                # if switch is att-ptp or 1DN/1SPID configured, set to 2"
	puts $te "                                # if sharing mpt-line with a phone, set to 2 (mixed voice-data)"
	puts $te "                                #"
	puts $te "#dl_rc_nb                1000    # N202 retry count to activate layer 2"
	puts $te "\n"
	puts $te "#dl_sapi                 63      # MGT"
	puts $te "#dl_dlcep_nb             3       # if 2DNs/2SPIDS configured, set to 3 (ni1/2, dms, att-mtp)"
	puts $te "                                # if switch is att-ptp or 1DN/1SPID configured, set to 2"
	puts $te "                                # if sharing mpt-line with a phone, set to 2 (mixed voice-data)"
	puts $te "                                #"
	puts $te "#dl_rc_nb                1000    # N202 retry count to activate layer 2"
}
	puts $te "#  end of US switch parameters"
	puts $te "\n"
	puts $te "#---------------------------------------------------------------------------"
	puts $te "ph_config               # Physical layer parameters"
	puts $te "#---------------------------------------------------------------------------"

	apply_success
close $te
	
}
