
#
# menu bar
#


proc MkTraceMenu {top} {

    set w [frame $top.localf1 -bd 2 -relief raised]

    menubutton $w.file -menu $w.file.m -text File -underline 0
    menubutton $w.help -menu $w.help.m -text Help -underline 0

    menu $w.file.m
    $w.file.m add command -label "Dismiss" -command "destroy $top"  \
        -underline 0

    menu $w.help.m
    $w.help.m add command -under 0  -label "On Trace" \
        -command "help_trace .help_trace" -under 3

    tixForm $w.file
    tixForm $w.help -right -1

    return $w
}

#
# Trace callback.
#
 
proc TraceInput  { }  {
        global textTraceWin
        global traceFileId
        if {[gets $traceFileId line] < 0} {
                close $traceFileId
		set traceFileId -1
                set line "\n...end of trace...\n"
        }
  	if { [winfo exists  .isdn_trace.textTrace] == 1 } {
        	$textTraceWin insert end "$line\n"
        	$textTraceWin yview -pickplace end
	}

}


proc destroy_trace { } {
	global traceFileId
        if { $traceFileId > -1 } {
        set f [pid $traceFileId]
        catch [exec kill -9 $f]
        catch {destroy .isdn_trace}
        close $traceFileId
        global tracepid
        set tracepid $f
        }  
        catch {destroy .isdn_trace}
}

# TODO: remove this procedure
# this info is provided by the parser (see list)

proc get_switch_type {cmd} {
	set catfile [exec /usr/bin/cat /etc/opt/SUNWisdn/te/0]
	set awkprt {printf $2}
	set awkcmd [list /^$cmd/ $awkprt]
	return [exec /usr/bin/awk $awkcmd << $catfile ]
}

proc create_trace { w  args } {

  	if { [winfo exists  $w] == 1 } {
		wm deiconify $w
		return
  	}
	set trc [exec /bin/ps -aef | grep isdntrace | wc -l]
	set trc_run 0
	global traceFileId
	if {$trc >= 2} {
		if [info exists traceFileId] {
			set trc_run 1
		} else {
			toplevel $w
			wm title $w "error"
			wm position $w ""
			wm iconname $w "error"
			text $w.errormsg -bd 2 -width 35 -height 3\
			-font -Adobe-times-medium-r-normal--*-180*
			$w.errormsg insert end " only one isdntrace allowed.\n\
			please stop all other isdntrace processes."
			pack $w.errormsg -side top
			button $w.error_dismiss -text Dismiss -command "destroy $w"
			pack $w.error_dismiss -side bottom
			update idletasks
			return
		}
	}
			

	toplevel $w
	wm title $w {isdntrace}
	wm positionfrom $w ""
	wm sizefrom $w ""
	wm minsize $w 100 100
	wm iconname $w "trace"
 	wm iconbitmap $w @ppm/logo.bmp

	
	# create menu widgets(s)

	set frame1 [MkTraceMenu       $w]
	pack $frame1 -side top    -fill x


	# create text widget

	text $w.textTrace -relief raised -bd 2 \
		-yscrollcommand "$w.scroll set"	-background lightgrey

	scrollbar $w.scroll -command "$w.textTrace yview"
	pack $w.scroll -side right -fill y
	#pack $w.textTrace -side left
	pack $w.textTrace -side top -fill both -expand true

	frame $w.trace_dismiss -relief raised -borderwidth 1
	pack $w.trace_dismiss -side top -fill x
	button $w.trace_dismiss.dismiss -text Dismiss -command destroy_trace
	pack $w.trace_dismiss.dismiss -side bottom -in $w.trace_dismiss -fill x
	
	update idletasks

	# trace parameters i.e switch type, etc ...
	# should be passed as arguments to this procedure.
 
	global textTraceWin
	set textTraceWin $w.textTrace

	global traceFileId
	set jk [get_switch_type cc_na_operator]
	set sw [string range $jk 0 2]

	# TODO: rewrite the following section.
	# this info is provided by the parser as a list.
	switch -exact -- $sw {
		"ntt" { set switch "ntt"}
		"vn6" { set switch "vn6"}
		"bt2" { set switch "bt2"}
		"tr6" { set switch "tr6"}
		"5es" { set switch "5ess"}
		"ets" { set switch "etsi"}
		"au1" { set switch "au1"}
		"ni2" { set switch "ni2"}
		"dms" { set switch "dms"}
		default { set switch "5ess"}
	}
	if {$trc_run == 0} {
		set traceFileId [ open  "|/opt/SUNWisdn/bin/isdntrace -n $switch &" ] 
	}
  	if { [winfo exists  $w.textTrace] == 1 } {
		fileevent $traceFileId readable TraceInput
  	}
	update idletasks

}


